
public class bachUpwithdate
{
    [DeclareAction("BackUpWithDate")]
    public void MyBackUp()
    {
        FolderBrowserDialog dlgBrowserOpen = new FolderBrowserDialog();

        if (dlgBrowserOpen.ShowDialog() == DialogResult.OK)
        {
            string strMeldung = "Wollen Sie das Projekt im Verzeichnis " 
                + Environment.NewLine
                + Environment.NewLine
                + dlgBrowserOpen.SelectedPath
                + Environment.NewLine
                + Environment.NewLine 
                + "sichern?"; 
 
            DialogResult result = MessageBox.Show(strMeldung,                         
                "Hier sichern?",
                MessageBoxButtons.YesNo,                          
                MessageBoxIcon.Question,                          
                MessageBoxDefaultButton.Button2);

            if (result == DialogResult.Yes)
            {

                string myTime = System.DateTime.Now.ToShortDateString();
                string hour = System.DateTime.Now.Hour.ToString();
                string minute = System.DateTime.Now.Minute.ToString();

                string Project = string.Empty;
                Project = GetProject(); 

                Progress progress = new Progress("SimpleProgress");
                progress.BeginPart(100, "");
                progress.SetAllowCancel(true);



                if (!progress.Canceled())
                {
                    progress.BeginPart(33, "Backup");
                    ActionCallingContext backupContext = new ActionCallingContext();
                    backupContext.AddParameter("BACKUPMEDIA", "DISK");
                    backupContext.AddParameter("BACKUPMETHOD", "BACKUP");
                    backupContext.AddParameter("COMPRESSPRJ", "0");
                    backupContext.AddParameter("INCLEXTDOCS", "1");
                    backupContext.AddParameter("BACKUPAMOUNT", "BACKUPAMOUNT_ALL");
                    backupContext.AddParameter("INCLIMAGES", "1");
                    backupContext.AddParameter("LogMsgActionDone", "true");
                    backupContext.AddParameter("DESTINATIONPATH", dlgBrowserOpen.SelectedPath);
                    backupContext.AddParameter("PROJECTNAME", Project);
                    backupContext.AddParameter("TYPE", "PROJECT");
                    backupContext.AddParameter("ARCHIVENAME", Project + "_" + hour + "." + minute + "h_" + myTime);
                    new CommandLineInterpreter().Execute("backup", backupContext);
                    progress.EndPart();
                    
                }
                progress.EndPart(true);
            }
            
            return;
        }
    }
	
	[DeclareMenu()]
	    public void MenuFunction()
	    {
	        Eplan.EplApi.Gui.Menu oMenu = new Eplan.EplApi.Gui.Menu();
	        oMenu.AddMenuItem("Projekt mit Uhrzeit und Datum...",
	        				"BackUpWithDate",
	        				"Projektsicherung mit Datum und Uhrzeit im Sicherungsnamen",
							System.UInt32.Parse("35119"), 	
							System.Int32.Parse("1"), 	
							false,
							true);
	    }
    
    public string GetProject()
    {

        string strProject = "";

        ActionCallingContext ProjectContext = new ActionCallingContext();
        ProjectContext.AddParameter("TYPE", "PROJECT");

        new CommandLineInterpreter().Execute("selectionset", ProjectContext);
        ProjectContext.GetParameter("PROJECT", ref strProject);

        return strProject;
    }
}
